Index: vl.c
===================================================================
--- vl.c	(revision 4734)
+++ vl.c	(working copy)
@@ -8255,59 +9276,385 @@
 #endif
 #ifdef TARGET_ARM
             case QEMU_OPTION_old_param:
-                old_param = 1;
+                qemu_device_set_bool(machine_dev, "old_param", 1);
                 break;
 #endif
             case QEMU_OPTION_clock:
-                configure_alarms(optarg);
+                qemu_device_set_str(qemu_prefs, "clock", optarg);
                 break;
             case QEMU_OPTION_startdate:
-                {
-                    struct tm tm;
-                    time_t rtc_start_date;
-                    if (!strcmp(optarg, "now")) {
-                        rtc_date_offset = -1;
-                    } else {
-                        if (sscanf(optarg, "%d-%d-%dT%d:%d:%d",
-                               &tm.tm_year,
-                               &tm.tm_mon,
-                               &tm.tm_mday,
-                               &tm.tm_hour,
-                               &tm.tm_min,
-                               &tm.tm_sec) == 6) {
-                            /* OK */
-                        } else if (sscanf(optarg, "%d-%d-%d",
-                                          &tm.tm_year,
-                                          &tm.tm_mon,
-                                          &tm.tm_mday) == 3) {
-                            tm.tm_hour = 0;
-                            tm.tm_min = 0;
-                            tm.tm_sec = 0;
-                        } else {
-                            goto date_fail;
-                        }
-                        tm.tm_year -= 1900;
-                        tm.tm_mon--;
-                        rtc_start_date = mktimegm(&tm);
-                        if (rtc_start_date == -1) {
-                        date_fail:
-                            fprintf(stderr, "Invalid date format. Valid format are:\n"
-                                    "'now' or '2006-06-17T16:01:21' or '2006-06-17'\n");
-                            exit(1);
-                        }
-                        rtc_date_offset = time(NULL) - rtc_start_date;
-                    }
-                }
+                qemu_device_set_str(machine_dev, "startdate", optarg);
                 break;
             case QEMU_OPTION_tb_size:
-                tb_size = strtol(optarg, NULL, 0);
-                if (tb_size < 0)
-                    tb_size = 0;
+                qemu_device_set_int(qemu_prefs, "tb_size", 
+                                    strtol(optarg, NULL, 0));
                 break;
+            case QEMU_OPTION_md:
+                if (qemu_parse_config(&machine_dev, optarg, 
+                                      QEMU_CONF_ERR_FILE) < 0)
+                    exit(1);
+                has_config = 1;
+                break;
+            case QEMU_OPTION_f:
+                /* already handled */
+                break;
+            case QEMU_OPTION_dump_devices:
+                do_dump_devices = 1;
+                break;
             }
         }
     }
 
+    if (!has_config) {
+        /* if no network clients, we use a default config */
+        machine = find_machine(machine_dev->dev_class->name);
+        if (nb_net_clients == 0 && machine && machine->default_nic_model) {
+            net_add("nic");
+            net_add("user");
+        }
+
+        /* if no config file, we always create the cdrom drive, even
+           if no disk is there */
+
+        if (nb_drives_opt < MAX_DRIVES)
+            drive_add(NULL, CDROM_ALIAS);
+        
+        /* we always create at least one floppy */
+        
+        if (nb_drives_opt < MAX_DRIVES)
+            drive_add(NULL, FD_ALIAS, 0);
+        
+        /* we always create one sd slot, even if no card is in it */
+        
+        if (nb_drives_opt < MAX_DRIVES)
+            drive_add(NULL, SD_ALIAS);
+    }
+
+    /* set net-user options */
+    {
+        QEMUDevice *dev;
+        int i;
+        char buf[64];
+
+        for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+            if (!strcmp(dev->dev_class->name, "net-user"))
+                break;
+        }
+        if (dev) {
+            if (slirp_tftp_prefix) 
+                qemu_device_set_str(dev, "tftp", slirp_tftp_prefix);
+            if (slirp_bootp_filename) 
+                qemu_device_set_str(dev, "bootp", slirp_bootp_filename);
+            if (slirp_smb_path) 
+                qemu_device_set_str(dev, "smb", slirp_smb_path);
+            for(i = 0; i < nb_slirp_redirs; i++) {
+                snprintf(buf, sizeof(buf), "redir%d", i);
+                qemu_device_set_str(dev, buf, slirp_redirs[i]);
+            }
+        }
+    }
+
+    if (use_gdbstub) {
+        qemu_device_set_str(machine_dev, "gdb_server", gdbstub_port);
+    }
+
+    if (do_dump_devices) {
+        dump_devices();
+    }
+
+    /* read back user preferences */
+    ui_str = qemu_device_get_str(qemu_prefs, "ui");
+    if (ui_str[0] == '\0') {
+        /* default ui */
+#if defined(CONFIG_SDL)
+        ui_str = "sdl";
+#elif defined(CONFIG_COCOA)
+        ui_str = "cocoa";
+#else
+        ui_str = "cmdline";
+#endif
+    }
+    if (!strcmp(ui_str, "cmdline")) {
+        nographic = 1;
+    } else 
+    if (!strcmp(ui_str, "vnc")) {
+        vnc_display = qemu_device_get_str(qemu_prefs, "vnc_params");
+    } else 
+#if defined(CONFIG_SDL)
+    if (!strcmp(ui_str, "sdl")) {
+    } else 
+#endif
+#if defined(CONFIG_CURSES)
+    if (!strcmp(ui_str, "curses")) {
+    } else
+#endif
+#if defined(CONFIG_COCOA)
+    if (!strcmp(ui_str, "cocoa")) {
+    } else
+#endif
+    {
+        fprintf(stderr, "qemu: invalid user interface: '%s'\n", ui_str);
+        exit(1);
+    }
+    full_screen = qemu_device_get_bool(qemu_prefs, "full_screen");
+#ifdef CONFIG_SDL
+    no_frame = qemu_device_get_bool(qemu_prefs, "sdl_no_frame");
+    alt_grab = qemu_device_get_bool(qemu_prefs, "sdl_alt_grab");
+    no_quit = qemu_device_get_bool(qemu_prefs, "sdl_no_quit");
+    cursor_hide = !qemu_device_get_bool(qemu_prefs, "sdl_show_cursor");
+#endif
+    keyboard_layout = str_zton(qemu_device_get_str(qemu_prefs, "keyboard_layout"));
+    daemonize = qemu_device_get_bool(qemu_prefs, "daemonize");
+    pid_file = str_zton(qemu_device_get_str(qemu_prefs, "pidfile"));
+    str = qemu_device_get_str(qemu_prefs, "clock");
+    if (str[0] != '\0')
+        configure_alarms(str);
+    tb_size = qemu_device_get_int(qemu_prefs, "tb_size");
+    if (tb_size < 0)
+        tb_size = 0;
+
+    /* read back machine config */
+    machine = find_machine(machine_dev->dev_class->name);
+    snapshot = qemu_device_get_bool(machine_dev, "snapshot");
+    cpu_model = str_zton(qemu_device_get_str(machine_dev, "cpu"));
+    initrd_filename = str_zton(qemu_device_get_str(machine_dev, "initrd"));
+    kernel_filename = str_zton(qemu_device_get_str(machine_dev, "kernel"));
+    kernel_cmdline = qemu_device_get_str(machine_dev, "append");
+    graphic_rotate = qemu_device_get_bool(machine_dev, "portrait");
+    rtc_utc = !qemu_device_get_bool(machine_dev, "localtime");
+    no_reboot = !qemu_device_get_bool(machine_dev, "reboot");
+    no_shutdown = !qemu_device_get_bool(machine_dev, "shutdown");
+#ifdef TARGET_ARM
+    old_param = qemu_device_get_bool(machine_dev, "old_param");
+#endif
+#if defined(TARGET_ARM) || defined(TARGET_M68K)
+    semihosting_enabled = qemu_device_get_bool(machine_dev, "semihosting");
+#endif
+#ifdef TARGET_I386
+    /* XXX: move that to hw/pc.c */
+    acpi_enabled = qemu_device_get_bool(machine_dev, "acpi");
+    win2k_install_hack = qemu_device_get_bool(machine_dev, "win2k_hack");
+    fd_bootchk = qemu_device_get_bool(machine_dev, "fd_bootchk");
+    {
+        str = qemu_device_get_str(machine_dev, "display");
+        if (str[0] == '\0')
+            str = "cirrus";
+        if (!strcmp(str, "vga")) {
+            cirrus_vga_enabled = 0;
+            vmsvga_enabled = 0;
+        } else if (!strcmp(str, "cirrus")) {
+            cirrus_vga_enabled = 1;
+            vmsvga_enabled = 0;
+        } else if (!strcmp(str, "vmsvga")) {
+            cirrus_vga_enabled = 0;
+            vmsvga_enabled = 1;
+        } else {
+            fprintf(stderr, "qemu: unsupported display: '%s'\n", str);
+            exit(1);
+        }
+    }
+#ifdef USE_KQEMU
+    str = qemu_device_get_str(machine_dev, "kqemu");
+    if (str[0] != '\0') {
+        if (!strcmp(str, "no")) {
+            kqemu_allowed = 0;
+        } else if (!strcmp(str, "user")) {
+            kqemu_allowed = 1;
+        } else if (!strcmp(str, "kernel")) {
+            kqemu_allowed = 2;
+        } else {
+            fprintf(stderr, "qemu: invalid kqemu value: '%s'\n", str);
+            exit(1);
+        }
+    }
+#endif
+#endif
+#if defined(TARGET_PPC) || defined(TARGET_SPARC)
+    {
+        const char *p;
+        int w, h, depth;
+        p = qemu_device_get_str(machine_dev, "display_params");
+        w = strtol(p, (char **)&p, 10);
+        if (w <= 0) {
+        graphic_error:
+            fprintf(stderr, "qemu: invalid resolution or depth\n");
+            exit(1);
+        }
+        if (*p != 'x')
+            goto graphic_error;
+        p++;
+        h = strtol(p, (char **)&p, 10);
+        if (h <= 0)
+            goto graphic_error;
+        if (*p != 'x') 
+            goto graphic_error;
+        p++;
+        depth = strtol(p, (char **)&p, 10);
+        if (depth != 8 && depth != 15 && depth != 16 &&
+            depth != 24 && depth != 32)
+            goto graphic_error;
+        
+        graphic_width = w;
+        graphic_height = h;
+        graphic_depth = depth;
+    }
+#endif
+    qemu_name = str_zton(qemu_device_get_str(machine_dev, "name"));
+    autostart = qemu_device_get_bool(machine_dev, "autostart");
+    term_escape_char = qemu_device_get_int(machine_dev, "term_escape_char");
+    {
+        int i;
+        char buf[128];
+        monitor_device = str_zton(qemu_device_get_str(machine_dev, "monitor"));
+        for(i = 0; i < MAX_SERIAL_PORTS; i++) {
+            snprintf(buf, sizeof(buf), "serial%d", i);
+            serial_devices[i] = str_zton(qemu_device_get_str(machine_dev, buf));
+        }
+        for(i = 0; i < MAX_PARALLEL_PORTS; i++) {
+            snprintf(buf, sizeof(buf), "parallel%d", i);
+            parallel_devices[i] = str_zton(qemu_device_get_str(machine_dev, buf));
+        }
+    }
+
+    /* set default devices */
+    if (nographic) {
+        if (!monitor_device)
+            monitor_device = "stdio";
+        if (!serial_devices[0])
+            serial_devices[0] = "stdio";
+        if (!parallel_devices[0])
+            parallel_devices[0] = "null";
+    } else {
+        if (!monitor_device)
+            monitor_device = "vc:800x600";
+        if (!serial_devices[0])
+            serial_devices[0] = "vc:80Cx24C";
+        if (!parallel_devices[0])
+            parallel_devices[0] = "vc:80Cx24C";
+    }
+    
+    str = qemu_device_get_str(machine_dev, "bios_dir");
+    if (str[0] != '\0')
+        bios_dir = str;
+    bios_name = str_zton(qemu_device_get_str(machine_dev, "bios"));
+
+    {
+        int mask;
+        CPULogItem *item;
+        const char *str;
+        str = qemu_device_get_str(machine_dev, "debug");
+        if (str[0] != '\0') {
+            mask = cpu_str_to_log_mask(str);
+            if (!mask) {
+                printf("Log items (comma separated):\n");
+                for(item = cpu_log_items; item->mask != 0; item++) {
+                    printf("%-10s %s\n", item->name, item->help);
+                }
+                exit(1);
+            }
+            cpu_set_log(mask);
+        }
+    }
+    {
+        smp_cpus = qemu_device_get_int(machine_dev, "smp");
+        if (smp_cpus < 1 || smp_cpus > MAX_CPUS) {
+            fprintf(stderr, "Invalid number of CPUs\n");
+            exit(1);
+        }
+    }
+
+    {
+        uint64_t value;
+        value = qemu_device_get_int(machine_dev, "ramsize");
+        value <<= 20;
+
+        /* On 32-bit hosts, QEMU is limited by virtual address space */
+        if (value > (2047 << 20)
+#ifndef USE_KQEMU
+            && HOST_LONG_BITS == 32
+#endif
+            ) {
+            fprintf(stderr, "qemu: at most 2047 MB RAM can be simulated\n");
+            exit(1);
+        }
+        if (value != (uint64_t)(ram_addr_t)value) {
+            fprintf(stderr, "qemu: ram size too large\n");
+            exit(1);
+        }
+        ram_size = value;
+    }
+    
+    {
+        /* Could easily be extended to 64 devices if needed */
+        const char *p;
+        
+        boot_devices = qemu_device_get_str(machine_dev, "boot");
+        boot_devices_bitmap = 0;
+        for (p = boot_devices; *p != '\0'; p++) {
+            /* Allowed boot devices are:
+             * a b     : floppy disk drives
+             * c ... f : IDE disk drives
+             * g ... m : machine implementation dependant drives
+             * n ... p : network devices
+             * It's up to each machine implementation to check
+             * if the given boot devices match the actual hardware
+             * implementation and firmware features.
+             */
+            if (*p < 'a' || *p > 'q') {
+                fprintf(stderr, "Invalid boot device '%c'\n", *p);
+                exit(1);
+            }
+            if (boot_devices_bitmap & (1 << (*p - 'a'))) {
+                fprintf(stderr,
+                        "Boot device '%c' was given twice\n",*p);
+                            exit(1);
+            }
+            boot_devices_bitmap |= 1 << (*p - 'a');
+        }
+    }
+
+    {
+        struct tm tm;
+        time_t rtc_start_date;
+        const char *start_date;
+        start_date = qemu_device_get_str(machine_dev, "startdate");
+        if (start_date[0] == '\0' || !strcmp(start_date, "now")) {
+            rtc_date_offset = -1;
+        } else {
+            if (sscanf(start_date, "%d-%d-%dT%d:%d:%d",
+                       &tm.tm_year,
+                       &tm.tm_mon,
+                       &tm.tm_mday,
+                       &tm.tm_hour,
+                       &tm.tm_min,
+                       &tm.tm_sec) == 6) {
+                /* OK */
+            } else if (sscanf(start_date, "%d-%d-%d",
+                              &tm.tm_year,
+                              &tm.tm_mon,
+                              &tm.tm_mday) == 3) {
+                tm.tm_hour = 0;
+                tm.tm_min = 0;
+                tm.tm_sec = 0;
+            } else {
+                goto date_fail;
+            }
+            tm.tm_year -= 1900;
+            tm.tm_mon--;
+            rtc_start_date = mktimegm(&tm);
+            if (rtc_start_date == -1) {
+            date_fail:
+                fprintf(stderr, "Invalid date format. Valid format are:\n"
+                        "'now' or '2006-06-17T16:01:21' or '2006-06-17'\n");
+                exit(1);
+            }
+            rtc_date_offset = time(NULL) - rtc_start_date;
+        }
+    }
+    gdbstub_port = str_zton(qemu_device_get_str(machine_dev, "gdb_server"));
+    usb_enabled = qemu_device_get_bool(machine_dev, "usb");
+    loadvm = str_zton(qemu_device_get_str(machine_dev, "loadvm"));
+
 #ifndef _WIN32
     if (daemonize && !nographic && vnc_display == NULL) {
 	fprintf(stderr, "Can only daemonize if using -nographic or -vnc\n");
@@ -8377,7 +9724,7 @@
 
     /* XXX: this should not be: some embedded targets just have flash */
     if (!linux_boot && net_boot == 0 &&
-        nb_drives_opt == 0)
+        nb_drives_opt == 0 && !has_config)
         help(1);
 
     /* boot to floppy or the default cd if no hard disk defined yet */
@@ -8394,53 +9741,52 @@
     socket_init();
 #endif
 
-    /* init network clients */
-    if (nb_net_clients == 0) {
-        /* if no clients, we use a default config */
-        net_clients[0] = "nic";
-        net_clients[1] = "user";
-        nb_net_clients = 2;
-    }
 
-    for(i = 0;i < nb_net_clients; i++) {
-        if (net_client_init(net_clients[i]) < 0)
-            exit(1);
-    }
-    for(vlan = first_vlan; vlan != NULL; vlan = vlan->next) {
-        if (vlan->nb_guest_devs == 0 && vlan->nb_host_devs == 0)
-            continue;
-        if (vlan->nb_guest_devs == 0) {
-            fprintf(stderr, "Invalid vlan (%d) with no nics\n", vlan->id);
-            exit(1);
+#ifdef TARGET_I386
+    {
+        char buf[128];
+        const char *str;
+
+        nb_option_roms = 0;
+        while (nb_option_roms < MAX_OPTION_ROMS) {
+            snprintf(buf, sizeof(buf), "option_rom%d", nb_option_roms);
+            str = qemu_device_get_str(machine_dev, buf);
+            if (str[0] == '\0')
+                break;
+            option_rom[nb_option_roms++] = str;
         }
-        if (vlan->nb_host_devs == 0)
-            fprintf(stderr,
-                    "Warning: vlan %d is not connected to host network\n",
-                    vlan->id);
     }
 
-#ifdef TARGET_I386
     /* XXX: this should be moved in the PC machine instantiation code */
+    /* XXX: it would have been better to add a ROM option to the
+       network adapter */
     if (net_boot != 0) {
         int netroms = 0;
-	for (i = 0; i < nb_nics && i < 4; i++) {
-	    const char *model = nd_table[i].model;
-	    char buf[1024];
-            if (net_boot & (1 << i)) {
-                if (model == NULL)
-                    model = "ne2k_pci";
-                snprintf(buf, sizeof(buf), "%s/pxe-%s.bin", bios_dir, model);
-                if (get_image_size(buf) > 0) {
-                    if (nb_option_roms >= MAX_OPTION_ROMS) {
-                        fprintf(stderr, "Too many option ROMs\n");
-                        exit(1);
+        QEMUDevice *dev;
+        QEMUDeviceClass *dc;
+        i = 0;
+        for(dev = qemu_first_device; dev != NULL; dev = dev->dev_next) {
+            dc = dev->dev_class;
+            if (qemu_class_instanceof(dc, qemu_eth_class)) {
+                const char *model = dc->name;
+                char buf[1024];
+                if (net_boot & (1 << i)) {
+                    snprintf(buf, sizeof(buf), "%s/pxe-%s.bin", bios_dir, model);
+                    if (get_image_size(buf) > 0) {
+                        if (nb_option_roms >= MAX_OPTION_ROMS) {
+                            fprintf(stderr, "Too many option ROMs\n");
+                            exit(1);
+                        }
+                        option_rom[nb_option_roms] = strdup(buf);
+                        nb_option_roms++;
+                        netroms++;
                     }
-                    option_rom[nb_option_roms] = strdup(buf);
-                    nb_option_roms++;
-                    netroms++;
                 }
+                i++;
+                if (i >= 4)
+                    break;
             }
-	}
+        }
 	if (netroms == 0) {
 	    fprintf(stderr, "No valid PXE rom found for network device\n");
 	    exit(1);
@@ -8480,27 +9826,9 @@
 
     bdrv_init();
 
-    /* we always create the cdrom drive, even if no disk is there */
-
-    if (nb_drives_opt < MAX_DRIVES)
-        drive_add(NULL, CDROM_ALIAS);
-
-    /* we always create at least one floppy */
-
-    if (nb_drives_opt < MAX_DRIVES)
-        drive_add(NULL, FD_ALIAS, 0);
-
-    /* we always create one sd slot, even if no card is in it */
-
-    if (nb_drives_opt < MAX_DRIVES)
-        drive_add(NULL, SD_ALIAS);
-
     /* open the virtual block devices */
+    drives_init();
 
-    for(i = 0; i < nb_drives_opt; i++)
-        if (drive_init(&drives_opt[i], snapshot, machine) == -1)
-	    exit(1);
-
     register_savevm("timer", 0, 2, timer_save, timer_load, NULL);
     register_savevm("ram", 0, 2, ram_save, ram_load, NULL);
 
@@ -8508,35 +9836,36 @@
 
     /* terminal init */
     memset(&display_state, 0, sizeof(display_state));
-    if (nographic) {
-        if (curses) {
-            fprintf(stderr, "fatal: -nographic can't be used with -curses\n");
-            exit(1);
-        }
-        /* nearly nothing to do */
+    if (!strcmp(ui_str, "cmdline")) {
         dumb_display_init(ds);
-    } else if (vnc_display != NULL) {
+    } else 
+    if (!strcmp(ui_str, "vnc")) {
         vnc_display_init(ds);
         if (vnc_display_open(ds, vnc_display) < 0)
             exit(1);
     } else
 #if defined(CONFIG_CURSES)
-    if (curses) {
+    if (!strcmp(ui_str, "curses")) {
         curses_display_init(ds, full_screen);
     } else
 #endif
-    {
 #if defined(CONFIG_SDL)
+    if (!strcmp(ui_str, "sdl")) {
         sdl_display_init(ds, full_screen, no_frame);
-#elif defined(CONFIG_COCOA)
+    } else
+#endif
+#if defined(CONFIG_COCOA)
+    if (!strcmp(ui_str, "cocoa")) {
         cocoa_display_init(ds, full_screen);
-#else
-        dumb_display_init(ds);
+    } else
 #endif
+    {
+        fprintf(stderr, "qemu: invalid user interface: '%s'\n", ui_str);
+        exit(1);
     }
 
     /* Maintain compatibility with multiple stdio monitors */
-    if (!strcmp(monitor_device,"stdio")) {
+    if (monitor_device && !strcmp(monitor_device,"stdio")) {
         for (i = 0; i < MAX_SERIAL_PORTS; i++) {
             const char *devname = serial_devices[i];
             if (devname && !strcmp(devname,"mon:stdio")) {
@@ -8586,17 +9915,23 @@
         }
     }
 
+    machine_dev->instantiated = 1;
     machine->init(ram_size, vga_ram_size, boot_devices, ds,
                   kernel_filename, kernel_cmdline, initrd_filename, cpu_model);
 
-    /* init USB devices */
-    if (usb_enabled) {
-        for(i = 0; i < usb_devices_index; i++) {
-            if (usb_device_add(usb_devices[i]) < 0) {
-                fprintf(stderr, "Warning: could not add USB device %s\n",
-                        usb_devices[i]);
-            }
+    generic_device_init();
+
+    for(vlan = first_vlan; vlan != NULL; vlan = vlan->next) {
+        if (vlan->nb_guest_devs == 0 && vlan->nb_host_devs == 0)
+            continue;
+        if (vlan->nb_guest_devs == 0) {
+            fprintf(stderr, "Invalid vlan (%d) with no nics\n", vlan->id);
+            exit(1);
         }
+        if (vlan->nb_host_devs == 0)
+            fprintf(stderr,
+                    "Warning: vlan %d is not connected to host network\n",
+                    vlan->id);
     }
 
     if (display_state.dpy_refresh) {
@@ -8605,7 +9940,7 @@
     }
 
 #ifdef CONFIG_GDBSTUB
-    if (use_gdbstub) {
+    if (gdbstub_port) {
         /* XXX: use standard host:port notation and modify options
            accordingly. */
         if (gdbserver_start(gdbstub_port) < 0) {
Index: net.h
===================================================================
--- net.h	(revision 4734)
+++ net.h	(working copy)
@@ -40,11 +40,7 @@
 
 struct NICInfo {
     uint8_t macaddr[6];
-    const char *model;
     VLANState *vlan;
 };
 
-extern int nb_nics;
-extern NICInfo nd_table[MAX_NICS];
-
 #endif
